﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
  using HeuristicLab.Algorithms.PushGP.Interpreter;

  public class CountOddsPushData : Data<long[], long>, IPushData {
    public CountOddsPushData(Example<long[], long>[] training, Example<long[], long>[] test)
      : base(training, test, 0, 50) {
    }

    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
      interpreter.IntegerStack.Push(Training[index].Input);
    }

    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
      interpreter.IntegerStack.Push(Test[index].Input);
    }

    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
      return this.CompareOutput(
        interpreter.IntegerStack,
        index,
        this.Training,
        data => data - interpreter.IntegerStack.Top);
    }

    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
      return this.CompareOutput(
        interpreter.IntegerStack,
        index,
        this.Test,
        data => data - interpreter.IntegerStack.Top);
    }
  }
}
