﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
  using HeuristicLab.Algorithms.PushGP.Interpreter;

  public class PigLatinPushData : Data<string, string>, IPushData {
    public PigLatinPushData(Example<string, string>[] training, Example<string, string>[] test)
      : base(training, test, 0, 128 * 70) {
    }

    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
      var asciiValues = GetAsciiValues(this.Training[index].Input);
      interpreter.IntegerStack.Push(asciiValues);
    }

    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
      var asciiValues = GetAsciiValues(this.Training[index].Input);
      interpreter.IntegerStack.Push(asciiValues);
    }

    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
      return this.CompareOutput(
        interpreter.IntegerStack,
        index,
        this.Training,
        data => GetAsciiResultDifference(data, interpreter.IntegerStack));
    }

    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
      return this.CompareOutput(
        interpreter.IntegerStack,
        index,
        this.Test,
        data => GetAsciiResultDifference(data, interpreter.IntegerStack));
    }
  }
}
